/*======================================智能人像分割（抠图）接口---人像抠图返回alpha通道======================================*/
package main

import (
	"bytes"
	"crypto/md5"
	"encoding/base64"
	"encoding/json"
	"fmt"
	"io/ioutil"
	"log"
	"net/http"
)

func ImgtoBase64SegmentAlpha(filePath string) string {
	//图片转Base64
	bytes, err := ioutil.ReadFile(filePath)
	if err != nil {
		log.Fatal(err)
	}
	var base64Encoding string
	base64Encoding += base64.StdEncoding.EncodeToString(bytes)
	return base64Encoding
}

func MD5SegmentAlpha(v string) string {
	d := []byte(v)
	m := md5.New()
	m.Write(d)
	b := m.Sum(nil)
	return base64.StdEncoding.EncodeToString([]byte(b))
}

func main() {
	appCode := "你的appcode"
	SegmentMattingUrl := "https://matting.market.alicloudapi.com/segment/alpha"

	client := &http.Client{}
	data := make(map[string]interface{})
	data["photo"] = ImgtoBase64SegmentAlpha("1.jpg")
	data["type"] = "jpg"
	data["face_required"] = 0        // #整形，设置人像分割前是否检测必须有人脸存在，0为检测，1为不检测，默认为0，设置这个参数后，可能导致人体背影无法抠图

	bytesData, _ := json.Marshal(data)
	req, _ := http.NewRequest("POST", SegmentMattingUrl, bytes.NewReader(bytesData))
	req.Header.Set("Content-Type", "application/json")
	req.Header.Set("Authorization", "APPCODE "+appCode)

	md5Str := MD5SegmentAlpha(string(bytesData))
	req.Header.Set("Content-MD5", md5Str)

	resp, _ := client.Do(req)
	fmt.Println(resp.Header)
	fmt.Println(resp.Header["X-Ca-Error-Message"])
	body, _ := ioutil.ReadAll(resp.Body)
	fmt.Println(string(body))

}
